Qutebrowser Configuration
Table of Contents
Import
from qutebrowser.config.configfiles import ConfigAPI from qutebrowser.config.config import ConfigContainer import sys, os
Auto Config
Do not load config set with :set
command in qutebrowser.
config.load_autoconfig(True)
General config
c.aliases = {'w': 'session-save', 'q': 'quit', 'wq': 'quit --save'} c.auto_save.session = False c.backend = 'webengine' c.confirm_quit = ['downloads']
c.aliases['paywall'] = "open https://www.google.com/search?q=cache:{url}"
Qt
Linked to issue.
c.qt.workarounds.remove_service_workers = True
Content
c.content.autoplay = False c.content.notifications = False c.content.geolocation = 'ask' c.content.javascript.alert = True c.content.javascript.can_access_clipboard = True c.content.pdfjs = False c.content.proxy = 'system' c.content.blocking.method = 'both' c.content.blocking.adblock.lists = ['https://easylist.to/easylist/easylist.txt', 'https://easylist.to/easylist/easyprivacy.txt', 'https://secure.fanboy.co.nz/fanboy-cookiemonster.txt']
Editor
c.editor.command = ['/usr/bin/termite', '--class="Floating"', '-e', 'nvim {}']
Downloads
c.downloads.location.directory = '$HOME/Downloads/' c.downloads.location.prompt = True c.downloads.location.remember = True c.downloads.location.suggestion = 'path' c.downloads.position = 'bottom' c.downloads.remove_finished = 10000
File Select
c.fileselect.handler = "default" # c.fileselect.single_file.command = ['termine', '-e', 'ranger', '--choosefile', '{}'] # c.fileselect.multiple_files.command = ['termite', '-e', 'ranger', '--choosefiles', '{}']
Colors
# c.colors.webpage.darkmode.enabled = True
Fonts
c.fonts.default_family = ["Hack Nerd Font Mono", "DejaVu Sans Mono", "Monaco"] c.fonts.prompts = '10pt monospace' c.fonts.statusbar = '10pt monospace'
Input
c.input.insert_mode.auto_enter = True # Very annoying when automatically leave insert mode c.input.insert_mode.auto_leave = False c.input.insert_mode.auto_load = False c.input.insert_mode.plugins = True
New Instance Options
c.new_instance_open_target = 'tab' c.new_instance_open_target_window = 'last-focused'
Spell Check
c.spellcheck.languages = ['en-US', 'fr-FR']
Status Bar
# Hide the statusbar unless a message is shown. c.statusbar.position = 'bottom' # List of widgets displayed in the statusbar. # Valid values: # - url: Current page URL. # - scroll: Percentage of the current page position like `10%`. # - scroll_raw: Raw percentage of the current page position like `10`. # - history: Display an arrow when possible to go back/forward in history. # - tabs: Current active tab, e.g. `2`. # - keypress: Display pressed keys when composing a vi command. # - progress: Progress bar for the current page loading. c.statusbar.widgets = ['keypress', 'url', 'scroll', 'history', 'progress']
Tabs
# Open new tabs (middleclick/ctrl+click) in the background. c.tabs.background = True # Mouse button with which to close tabs. c.tabs.close_mouse_button = 'right' # How to behave when the last tab is closed. c.tabs.last_close = 'close' # Switch between tabs using the mouse wheel. c.tabs.mousewheel_switching = False # Position of new tabs opened from another tab. # Valid values: # - prev: Before the current tab. # - next: After the current tab. # - first: At the beginning. # - last: At the end. c.tabs.new_position.related = 'next' # Position of new tabs which aren't opened from another tab. # Valid values: # - prev: Before the current tab. # - next: After the current tab. # - first: At the beginning. # - last: At the end. c.tabs.new_position.unrelated = 'last' # Position of the tab bar. c.tabs.position = 'left' # Which tab to select when the focused tab is removed. c.tabs.select_on_remove = 'next' # Width (in pixels or as percentage of the window) of the tab bar if it's vertical. c.tabs.width = 30 # Wrap when changing tabs. c.tabs.wrap = False
Urls and Search Engines
c.url.searchengines = { 'DEFAULT': 'https://www.duckduckgo.org/?q={}', 'aw': 'https://wiki.archlinux.org/?search={}', 'wi': 'https://en.wikipedia.org/wiki/Special:Search?search={}', 'go': 'https://www.google.com/search?q={}', 'gc': 'https://scholar.google.fr/scholar?hl=fr&as_sdt=0%2C5&q={}&btnG=', 'gm': 'https://www.google.com/maps/search/{}/', 'yt': 'https://www.youtube.com/results?search_query={}', 'gh': 'https://github.com/search?q={}', 're': 'https://www.reddit.com/search?q={}', 'lb': 'http://gen.lib.rus.ec/search.php?req={}', 'la': 'http://gen.lib.rus.ec/scimag/index.php?s={}', 'sm': 'https://www.openstreetmap.org/search?query={}', 'am': 'https://www.amazon.fr/s?k={}', 'md': 'https://fr.mathworks.com/help/search.html?qdoc={}&submitsearch=', 'js': 'https://developer.mozilla.org/en-US/search?q={}', 'tf': 'https://translate.google.com/#view=home&op=translate&sl=en&tl=fr&text={}', 'te': 'https://translate.google.com/#view=home&op=translate&sl=fr&tl=en&text={}', }
c.url.start_pages = ['https://homer.tdehaeze.xyz/'] c.url.default_page = 'https://homer.tdehaeze.xyz/'
Normal Bindings
Zooming
config.bind('+', 'zoom-in') config.bind('-', 'zoom-out') config.bind('=', 'zoom')
Inputs blocks
config.bind(';t', 'hint inputs') config.bind('gi', 'hint inputs --first')
Opening New Window
config.bind('<Ctrl-N>', 'open -w')
History
config.bind('H', 'back') config.bind('L', 'forward')
Move tabs around
config.bind('d', 'tab-close') config.bind('<', 'tab-move -') config.bind('>', 'tab-move +') config.bind('gO', 'tab-give') # Open current tab in a new window config.bind('J', 'tab-next') config.bind('K', 'tab-prev')
Bookmarks and Quickmark
config.bind('M', 'bookmark-add') config.bind('m', 'quickmark-save')
Open New Pages/Tabs
config.bind('o', 'set-cmd-text -s :open') config.bind('O', 'set-cmd-text -s :open -t')
Open new page/tab with clipboard content
config.bind('pp', 'open -- {clipboard}') config.bind('pP', 'open -t -- {clipboard}')
Link Hinting
config.bind('f', 'hint') config.bind('F', 'hint all tab')
Yanking url
config.bind('yy', 'yank')
Go to specific websites
config.bind('gy', 'open -t https://www.youtube.com/feed/subscriptions') config.bind('gf', 'open -t https://rss.tdehaeze.xyz/') config.bind('gr', 'open -t https://www.reddit.com/') config.bind('gh', 'open -t https://homer.tdehaeze.xyz/') config.bind('gb', 'open -t qute://bookmarks') config.bind('gH', 'open -t qute://history') config.bind('gs', 'open -t qute://settings')
Custom Bindings
Create a Password for the current website
config.bind(',P', 'spawn --userscript ~/.config/qutebrowser/userscripts/add-passowrd.sh')
Use Pass to fill password and username (configuration is done in ~/.config/qutebrowser/password_fill_rc
)
config.bind(',p', 'spawn --userscript password_fill')
Open Youtube video using mpv
config.bind(',m', 'spawn --detach mpv --force-window yes {url}') config.bind(',M', 'hint links spawn --detach mpv --force-window yes {hint-url}')
Download Youtube video / entire playlist
config.bind(',v', 'spawn --userscript ~/.config/qutebrowser/userscripts/yt-download.sh {url}') config.bind(',V', 'hint links spawn --userscript ~/.config/qutebrowser/userscripts/yt-download.sh {hint-url}')
Add page to Bookmarks using buku
config.bind(',b', 'spawn --userscript ~/.config/qutebrowser/userscripts/buku-add.sh') config.bind(',B', 'spawn --userscript ~/.config/qutebrowser/userscripts/buku-rofi.sh')
Download with aria2c
config.bind(',d', 'hint links spawn --userscript ~/.config/qutebrowser/userscripts/aria2c-add.sh {hint-url}') config.bind(',D', 'hint links spawn --userscript ~/.config/qutebrowser/userscripts/aria2c-add-homelab.sh {hint-url}')
Open bookmark using buku
config.bind(',o', 'spawn ~/.local/bin/bukurun')
Org Capture
config.bind(',r', 'spawn --userscript ~/.config/qutebrowser/userscripts/org-capture.sh') config.bind(',R', 'hint links userscript ~/.config/qutebrowser/userscripts/org-capture.sh')
Screenshot of webpage to png
config.bind(',s', 'spawn --userscript ~/.config/qutebrowser/userscripts/html-to-pdf.sh') config.bind(',S', 'spawn --userscript ~/.config/qutebrowser/userscripts/html-to-png.sh')
Download AES video
config.bind(',E', 'spawn --userscript ~/.config/qutebrowser/userscripts/aes-download.sh')
Download a torrent
config.bind(',t', 'hint links spawn torrent-add {hint-url}')
Annotate with Hypothesis
config.bind(',a', "jseval javascript:(function(){window.hypothesisConfig=function(){return{showHighlights:true,appType:'bookmarklet'};};var d=document,s=d.createElement('script');s.setAttribute('src','https://hypothes.is/embed.js');d.body.appendChild(s)})();")
See Amazon price history using CamelCamelCamel
config.bind(',A', "open -t https://fr.camelcamelcamel.com/search?sq={url}")
Org Roam Entry for the current page
config.bind(',R', "open javascript:void(location.href='org-protocol://roam-ref?template=r&ref='+encodeURIComponent(location.href)+'&title='+encodeURIComponent(document.title))")
config.bind(',Z', "open -w https://bm.tdehaeze.xyz/bookmarks/new?url={url}&auto_close")
Userscripts
Create a new password
url=$(echo "$QUTE_URL" | awk -F[/:] '{print $4}' | rofi -p "URL" -dmenu -lines 1) username=$(echo -e "dehaeze.thomas@gmail.com\nthomas.dehaeze@esrf.fr\ntdehaeze" | rofi -p "Username" -dmenu -lines 5) password=$(rofi -p "Password" -dmenu -password -lines 1) if [ -z "$url" ] || [ -z "$username" ] || [ -z "$password" ]; then dunstify --urgency=critical "Pass" "Failed to Add Password" else echo -e "$password\nlogin: $username\nurl: $QUTE_URL" > /tmp/add-password.txt pass insert --multiline "$url/$username" < /tmp/add-password.txt; rm /tmp/add-password.txt dunstify "Pass " "Password Added" fi
Download Youtube Video
cd ~/Documents/to-watch/ || exit; if [[ "$1" == *"list"* ]]; then choice=$(echo -e "Video\nPlaylist" | rofi -dmenu -only-match -i) fi if [ -n "$choice" ] && [ "$choice" = "Playlist" ]; then dunstify --replace=19243 "Youtube " "Downloading Playlist..."; youtube-dl -i -f 'bestvideo[height<=720]+bestaudio/best[height<=720]' "$1" -o "%(playlist_title)s/%(playlist_index)s-%(title)s.%(ext)s" && \ dunstify --replace=19243 "Youtube " "Downloaded" || \ dunstify --replace=19243 --urgency=critical "Youtube " "Failed to download" else dunstify --replace=19243 "Youtube " "Downloading Video..."; youtube-dl --no-playlist -f 'bestvideo[height<=720]+bestaudio/best[height<=720]' "$1" && \ dunstify --replace=19243 "Youtube " "Downloaded" || \ dunstify --replace=19243 --urgency=critical "Youtube " "Failed to download" fi
Password_fill_rc
# Show all password fields in the menu query_entries() { # safe queried url for choose_entry # the subdomains are removed export queried_url=$(expr match ".$1" '.*\.\(.*\..*\)') mapfile -t files < <(find -L "$PREFIX" -iname '*.gpg' -printf '%P\n' |sed 's,\.gpg$,,') } # Even if there is only one entry, always show a menu # for user confirmation. choose_entry() { MENU_COMMAND=( rofi -dmenu -p "qutebrowser> " -filter "$queried_url" -mesg $'Pick a password entry for <b>'"${QUTE_URL//&/&}"'</b>' ) file=$( printf "%s\n" "${files[@]}" | "${MENU_COMMAND[@]}" ) }
Org-Capture
readonly CAPTURE_SCRIPT=~/.config/qutebrowser/userscripts/org-protocol-capture-html.sh if [[ "$QUTE_MODE" = "hints" ]]; then # if we start with hints, we juste want to capture the URL $CAPTURE_SCRIPT --template "pu" --url "${QUTE_URL}" elif [[ -n "$QUTE_SELECTED_TEXT" ]]; then # if text is selected, we want to capture the text $CAPTURE_SCRIPT --template "pt" --heading "${QUTE_TITLE}" --url "${QUTE_URL}" "${QUTE_SELECTED_TEXT}" else # if no text is selected, we want to capture the url $CAPTURE_SCRIPT --template "pu" --heading "${QUTE_TITLE}" --url "${QUTE_URL}" fi
Org-Protocol-Capture-HTML
Defaults
heading="link" template="pu" url="https://google.com/"
Functions
function debug { if [[ -n $debug ]] then function debug { echo "DEBUG: $@" >&2 } debug "$@" else function debug { true } fi } function die { echo "$@" >&2 exit 1 } function urlencode { python -c " from __future__ import print_function try: from urllib import quote # Python 2 except ImportError: from urllib.parse import quote # Python 3 import sys print(quote(sys.stdin.read()[:-1], safe=''))" }
Documentation
function usage { cat <<EOF $0 [OPTIONS] [HTML] html | $0 [OPTIONS] Send HTML to Emacs through org-protocol, passing it through Pandoc to convert HTML to Org-mode. HTML may be passed as an argument or through STDIN. If only URL is given, it will be downloaded and its contents used. Options: -h, --heading HEADING Heading -t, --template TEMPLATE org-capture template key (default: pu) -u, --url URL URL --debug Print debug info --help I need somebody! EOF }
Arguments
args=$(getopt -n "$0" -o dh:rt:u: -l debug,help,heading:,template:,url: -- "$@") \ || die "Unable to parse args. Is getopt installed?" eval set -- "$args" while true do case "$1" in -d|--debug) debug=true debug "Debugging on" ;; --help) usage exit ;; -h|--heading) shift heading="$1" ;; -t|--template) shift template="$1" ;; -u|--url) shift url="$1" ;; --) # Remaining args shift rest=("$@") break ;; esac shift done debug "ARGS: $args" debug "Remaining args: ${rest[@]}"
Get HTML
if [[ -n $@ ]] then debug "Text from args" body="$@" fi
URL-encode
heading=$(urlencode <<<"$heading") || die "Unable to urlencode heading." url=$(urlencode <<<"$url") || die "Unable to urlencode URL." body=$(urlencode <<<"$body") || die "Unable to urlencode text."
Send to Emacs
emacsclient "org-protocol://capture?template=$template&url=$url&title=$heading&body=$body"
Add Url to Buku using Rofi
title=$(echo "$QUTE_TITLE" | rofi -p "Title" -dmenu -lines 1) tags=$(buku -t --nc --np | sed -e 's/\s*[[:digit:]]*\.\s*\(.*\)\s*([[:digit:]]*)\s*/\1/' -e '/^\s*$/d' | sort | uniq | rofi -multi-select -p "Tags" -dmenu | tr "\n" "," | sed 's/\s*,\s*$//') buku --add "$QUTE_URL" --tag "$tags" --title "$title" && \ dunstify "Buku" "Bookmark Added" || \ dunstify --urgency=critical "Buku" " Bookmark Added"
Add Url to Buku without asking for information
buku --add $QUTE_URL --title "$QUTE_TITLE" && \ dunstify "Buku" "📑 Bookmark Added"
Download with aria2c
aria2p add "$1" && \ dunstify "Aria2" "Download Started" || \ dunstify "Aria2" "Error"
Download with aria2c on the Homelab
dl-add $(echo "$1" | sed 's/\&af=.*$//g') && \ dunstify "Aria2" "Download Started" || \ dunstify "Aria2" "Error"
Screenshot
filename=$(rofi -p "filename" -dmenu -lines 1) if [ -n "filename" ]; then cd ~/Pictures/ && \ firefox-developer-edition -P default -headless --screenshot "$filename.png" "$QUTE_URL" && \ dunstify "Screenshot" "Taken successfully" fi
Save to PDF
filename=$(rofi -p "filename" -dmenu -lines 1) if [ -n "$filename" ]; then cd ~/Pictures/ && \ percollate pdf --css "@page { size: A4 portrait }" --output "$filename.pdf" "$QUTE_URL" && \ dunstify "Percollate" "Successfully saved to pdf" fi
Download AES video
m3u8_path=`curl -L -s "$QUTE_URL" | pcregrep -o1 "file = \"\/(.*aes.*mp4)\""` if [ -z "$m3u8_path" ]; then dunstify --urgency=critical "Qutebrowser" "No m3u8 playlist found" else dunstify "Qutebrowser" "Downloads..." && \ cd ~/Downloads/ && \ ffmpeg -user_agent "Mozilla/5.0 (X11; Linux x86_64; rv:84.0) Gecko/20100101 Firefox/84.0" -referer "$QUTE_URL" -i "https://cdn2.digitellinc.com/play/_definst_/mp4:$m3u8_path/playlist.m3u8" -c copy "$QUTE_TITLE.mp4" && \ dunstify "Qutebrowser" "$QUTE_TITLE Downloaded" fi